Attribute VB_Name = "mod"
'Declaraciones
Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

'Definir las constantes para hacer restricciones
'al Cuadro de Dialogo
Public Const OFN_READONLY = &H1
Public Const OFN_OVERWRITEPROMPT = &H2
Public Const OFN_HIDEREADONLY = &H4
Public Const OFN_NOCHANGEDIR = &H8
Public Const OFN_SHOWHELP = &H10
Public Const OFN_ENABLEHOOK = &H20
Public Const OFN_ENABLETEMPLATE = &H40
Public Const OFN_ENABLETEMPLATEHANDLE = &H80
Public Const OFN_NOVALIDATE = &H100
Public Const OFN_ALLOWMULTISELECT = &H200
Public Const OFN_EXTENSIONDIFFERENT = &H400
Public Const OFN_PATHMUSTEXIST = &H800
Public Const OFN_FILEMUSTEXIST = &H1000
Public Const OFN_CREATEPROMPT = &H2000
Public Const OFN_SHAREAWARE = &H4000
Public Const OFN_NOREADONLYRETURN = &H8000
Public Const OFN_NOTESTFILECREATE = &H10000
Public Const OFN_NONETWORKBUTTON = &H20000
Public Const OFN_NOLONGNAMES = &H40000
Public Const OFN_EXPLORER = &H80000
Public Const OFN_NODEREFERENCELINKS = &H100000
Public Const OFN_LONGNAMES = &H200000
Public Const OFN_SHAREFALLTHROUGH = 2
Public Const OFN_SHARENOWARN = 1
Public Const OFN_SHAREWARN = 0

'Definicin de las API's que llaman los cuadros de dialogo Abrir y Guardar
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long

'Funcion que llama al Cuadro de Dialogo Guardar
Function Cuadro_Dialogo_Guardar(Formulario As Form, Filtro As String, Titulo As String, DirInicial As String) As String
Dim ofn As OPENFILENAME
Dim Pos As Long
Dim Resultado As Long
ofn.lStructSize = Len(ofn)
'Que formulario va a ser el dueo del Dialogo
ofn.hwndOwner = Formulario.hWnd
ofn.hInstance = App.hInstance
'Comprueba que la cadena que contiene el Filtro de
'archivos este bien terminado con |
If Right$(Filtro, 1) <> "|" Then Filtro = Filtro + "|"
'Cambia los | por chr(0) para que el cuadro de dialogo
'lo pueda interpretar
For Pos = 1 To Len(Filtro)
 If Mid$(Filtro, Pos, 1) = "|" Then Mid$(Filtro, Pos, 1) = Chr$(0)
Next
'Define el Filtro
ofn.lpstrFilter = Filtro
'Define Otras
ofn.lpstrFile = Space$(254)
ofn.nMaxFile = 255
ofn.lpstrFileTitle = Space$(254)
ofn.nMaxFileTitle = 255
'Define Directorio inicial
ofn.lpstrInitialDir = DirInicial
'Define Titulo
ofn.lpstrTitle = Titulo
'Segn la constante que se le asigne,
'el cuadro va a tener distintas restrinciones
ofn.flags = OFN_HIDEREADONLY Or OFN_OVERWRITEPROMPT Or OFN_CREATEPROMPT
'Llamando al Cuadro de Dialogo
Resultado = GetSaveFileName(ofn)
'Segn el resultado, si es True devuelve el archivo
'seleccionado o el nombre del nuevo archivo
If (Resultado) Then
 Cuadro_Dialogo_Guardar = Trim$(ofn.lpstrFile)
Else
 Cuadro_Dialogo_Guardar = ""
End If
End Function

'Funcin que llama al Duadro de Dialogo Abrir
Function Cuadro_Dialogo_Abrir(Formulario As Form, Filtro As String, Titulo As String, DirInicial As String) As String
Dim ofn As OPENFILENAME
Dim Pos As Long
Dim Resultado As Long
ofn.lStructSize = Len(ofn)
'Que formulario va a ser el dueo del Dialogo
ofn.hwndOwner = Formulario.hWnd
ofn.hInstance = App.hInstance
'Comprueba que la cadena que contiene el Filtro de
'archivos este bien terminado con |
If Right$(Filtro, 1) <> "|" Then Filtro = Filtro + "|"
'Cambia los | por chr(0) para que el cuadro de dialogo
'lo pueda interpretar
For Pos = 1 To Len(Filtro)
 If Mid$(Filtro, Pos, 1) = "|" Then Mid$(Filtro, Pos, 1) = Chr$(0)
Next
'Define el Filtro
ofn.lpstrFilter = Filtro
'Define Otras
ofn.lpstrFile = Space$(254)
ofn.nMaxFile = 255
ofn.lpstrFileTitle = Space$(254)
ofn.nMaxFileTitle = 255
'Define Directorio inicial
ofn.lpstrInitialDir = DirInicial
'Define Titulo
ofn.lpstrTitle = Titulo
'Segn la constante que se le asigne,
'el cuadro va a tener distintas restrinciones
ofn.flags = OFN_HIDEREADONLY Or OFN_FILEMUSTEXIST
'Llamando al Cuadro de Dialogo
Resultado = GetOpenFileName(ofn)
'Segn el resultado, si es True devuelve el archivo
'seleccionado
If (Resultado) Then
 Cuadro_Dialogo_Abrir = Trim$(ofn.lpstrFile)
Else
 Cuadro_Dialogo_Abrir = ""
End If
End Function
